obj
  fsrwx : "fsrwx"
  term  : "fds1"
  sys   : "sysdefs"
  runp  : "runprog"

con
  filestuffsize = fsrwx#handle_size + fsrwx#sectorsize 

dat
  filestuff1 long 0[filestuffsize/4]
  filestuff2 long 0[filestuffsize/4]
  fileopened1 long 0
  fileopened2 long 0

PUB enter | pins
  term.start(31, 30, 0, 115200)
  pins := long[sys#sd_pins]
  fsrwx.mount_explicit(byte[@pins], byte[@pins][1], byte[@pins][2], byte[@pins][3])
  fsrwx.chdir(string("/sphinx"))

PUB exit(retval)
  CloseFiles
  StopCogsReturnLocks
  waitcnt(clkfreq/100 + cnt)
  long[sys#return_value] := retval
  runp.runprog(0, 0, long[sys#shell_sector], long[sys#shell_size], 0)

PUB StopCogsReturnLocks | cogspi, i
  ' Stop all the cogs except this one and the SD SPI cog
  cogspi := long[sys#SPI_engine_cog] - 1
  repeat i from 0 to 7
    if i <> cogid and i <> cogspi
      cogstop(i)

  ' Clear and return all the locks
  repeat i from 0 to 7
    lockclr(i)
    lockret(i)

pub Write(handle, ptr, num)
  return fsrwx.hwrite(handle, ptr, num)

pub Read(handle, ptr, num)
  return fsrwx.hread(handle, ptr, num)

pub Open(fname, mode)
  if fileopened1 and fileopened2
    term.str(string("Open: Out of file handles", 13, 10))
    waitcnt(clkfreq/10+cnt)
    reboot
  ifnot fileopened1
    ifnot fsrwx.hopen(@filestuff1, fname, mode+32)
      fileopened1 := 1
      result := @filestuff1
  elseifnot fileopened2
    ifnot fsrwx.hopen(@filestuff2, fname, mode+32)
      fileopened2 := 1
      result := @filestuff2

pub Close(handle)
  if handle == @filestuff1
    if fileopened1
      fsrwx.hclose(handle)
      fileopened1 := 0
  elseif handle == @filestuff2
    if fileopened2
      fsrwx.hclose(handle)
      fileopened2 := 0

pub CloseFiles
  Close(@filestuff1)
  Close(@filestuff2)

pub Start(DO, CLK, DI, CS)
  return \fsrwx.mount_explicit(DO, CLK, DI, CS)

pub ReadByte(handle)
  if fsrwx.hread(handle, @result, 1) <> 1
    result := -1

pub ReadString(handle, ptr, size)
  repeat while size => 1
    result := ReadByte(handle)
    if result =< 0 or result == 10 or result == " "
      quit
    byte[ptr++] := result
    size--
  byte[ptr++] := 0

pub ReadStringUpperCase(handle, ptr, size)
  ReadString(handle, ptr, size)
  repeat while byte[ptr]
    byte[ptr] := toupper(byte[ptr])
    ptr++

pub ReadLong(handle)
  fsrwx.hread(handle, @result, 4)

pub ReadWord(handle)
  fsrwx.hread(handle, @result, 2)

pub WriteLong(handle, val)
  fsrwx.hwrite(handle, @val, 4)

pub WriteString(handle, ptr)
  fsrwx.hwrite(handle, ptr, strsize(ptr)+1)

pub WriteByte(handle, val)
  fsrwx.hwrite(handle, @val, 1)

pub WriteWord(handle, val)
  fsrwx.hwrite(handle, @val, 2)

pub SkipBytes(handle, num)
  repeat while num-- > 0
    ReadByte(handle)

pub Execute(argc, argv) | handle, size, sector, fname, argv1
  CloseFiles
  fname := long[argv]
  handle := Open(fname, "R")
  ifnot handle
    term.str(string("Could not run "))
    term.str(fname)
    term.str(string(13, 10))
  sector := fsrwx.hget_first_sector(handle)
  size := fsrwx.hget_filesize(handle)

  StopCogsReturnLocks

  ' Copy the arg list to compact it
  argv1 := sys#argv_parms
  copyarglist(argc, argv, argv1)

  runp.runprog(argc, argv1, sector, size, 0)

PUB copyarglist(argc, argv, argv1) | ptr, i, num
  if argc > 0
    ptr := @long[argv1][argc+1]
    repeat i from 0 to argc - 1
      long[argv1][i] := ptr
      num := strsize(long[argv][i]) + 1
      bytemove(ptr, long[argv][i], num)
      ptr += num
    long[argv1][argc] := 0

pub atol(ptr)
  repeat while byte[ptr]
    result := (result * 10) + byte[ptr++] - "0"

pub toupper(val)
  if val => "a" and val =< "z"
    val -= 32
  return val

pub CopyUpperCase(dst, src)
  bytemove(dst, src, strsize(src)+1)
  repeat while byte[dst]
    byte[dst] := toupper(byte[dst])
    dst++

