'*********************************************
'* Spin code generated by cspin version 0.82 *
'*********************************************

'******************************************************************************
' Copyright (c) 2014 Dave Hein
' See end of file for terms of use.
'******************************************************************************
' INLINE SPIN
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c : "clibos"
  sys : "sysdefs"


PUB start(argc, argv)
  c.enter
  main(argc, argv)
  c.exit(0)

PUB atol(ptr) | val
  c.sscanf1(ptr, string("%d"), @val)
  return val


DAT
  t long 0, 3, 2, 5, 0, 3, 5, 1, 4, 6, 2, 4
  wday long @datstr + 16, @datstr + 23, @datstr + 30
  long @datstr + 38, @datstr + 48, @datstr + 57, @datstr + 64
  datstr byte "Sunday", 0, "Monday", 0, "Tuesday", 0
  byte "Wednesday", 0, "Thursday", 0, "Friday", 0, "Saturday", 0
  mname long @datstr_0 + 16, @datstr_0 + 24, @datstr_0 + 33, @datstr_0 + 39, @datstr_0 + 45, @datstr_0 + 49
  long @datstr_0 + 54, @datstr_0 + 59, @datstr_0 + 66, @datstr_0 + 76, @datstr_0 + 84, @datstr_0 + 93
  datstr_0 byte "January", 0, "February", 0, "March", 0, "April", 0, "May", 0, "June", 0
  byte "July", 0, "August", 0, "September", 0, "October", 0, "November", 0, "December", 0
  numdays long 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31

VAR
  byte buffer[560]

PUB dayofweek(y, m, d)
  y -= m < 3
  return (y + y / 4 - y / 100 + y / 400 + t[m - 1] + d) // 7

PUB RemoveExtraNulls | i, j, n
  i := 0
  repeat while (i < 8)
    ' Locate last null
    n := 70 - 1
    repeat while (n > 0)
      if (byte[@buffer + (70 * i)][n] == 0)
        quit
      n--
    ' Remove extra nulls
    j := 0
    repeat while (j < n)
      if (byte[@buffer + (70 * i)][j] == 0)
        byte[@buffer + (70 * i)][j] := " "
      j++
    i++

PUB PrintMonth(year, month, col) | ptr, row, i, num, first
  row := 0
  if (col => 0)
    num := (22 - strsize(mname[month - 1])) / 2
    c.sprintf1((@buffer + (70 * 0)) + col + num, string("%s"), mname[month - 1])
  else
    num := (17 - strsize(mname[month - 1])) / 2
    c.sprintf2((@buffer + (70 * 0)) + col + num, string("%s %d"), mname[month - 1], year)
    col := 0
  c.sprintf0((@buffer + (70 * 1)) + col, string("Su Mo Tu We Th Fr Sa"))
  row := 2
  ptr := (@buffer + (70 * 2)) + col
  first := dayofweek(year, month, 1)
  ptr += 3 * first
  num := numdays[month - 1]
  if (month == 2 and year // 4 == 0 and (year // 100 <> 0 or year // 400 == 0))
    num++
  i := 1
  repeat while (i =< num)
    c.sprintf1(ptr, string("%2d "), i)
    ptr += 3
    if (++first => 7)
      ptr := (@buffer + (70 * (++row))) + col
      first := 0
    i++
  if (first)
    row++
  return row

PUB usage
  c.printf0(string("usage: cal [[month] year]\n"))
  c.exit(1)

PUB main(argc, argv) | year, month, i, j, num
  if (argc > 3)
    usage
  if (argc == 2)
    year := atol(long[argv][1])
    c.printf1(string("                               %d\n\n"), year)
    j := 0
    repeat while (j < 12)
      c.memset((@buffer + (70 * 0)), " ", 8 * 70)
      num := PrintMonth(year, j + 1, 0)
      i := PrintMonth(year, j + 2, 23)
      num := lookupz(-(((i > num)) == 0) : i, num)
      i := PrintMonth(year, j + 3, 46)
      num := lookupz(-(((i > num)) == 0) : i, num)
      RemoveExtraNulls
      i := 0
      repeat while (i < num)
        c.printf1(string("%s\n"),(@buffer + (70 * i)))
        i++
      c.printf0(string("\n"))
      j += 3
  else
    if (argc == 3)
      month := atol(long[argv][1])
      year := atol(long[argv][2])
      if (month < 1 or month > 12)
        usage
    else
      getdate(@year, @month)
    c.memset((@buffer + (70 * 0)), " ", 8 * 70)
    num := PrintMonth(year, month, -1)
    i := 0
    repeat while (i < num)
      c.printf1(string("%s\n"),(@buffer + (70 * i)))
      i++
  return 0

' INLINE SPIN
pub getdate(year, month) | temp
  temp := date(long[sys#unixtime], long[sys#timezone])
  long[year] := word[@temp][1]
  long[month] := byte[@temp][1]
PUB date(unixtime, timezone) | yyyymmdd, year, month, day, leap
  day := floor_div(unixtime + timezone * 3600, 86400)
  year := floor_div(day << 2 + 2, 1461)
  word[@yyyymmdd][1] := year + 1970
  leap := floor_mod(year, 4) == 2
  day -= (year * 1461 + 1) ~> 2
  if (day > 58 - leap)
    day += leap + 2
  byte[@yyyymmdd][1] := (day * 12 + 6) / 367
  byte[@yyyymmdd][0] := day + 1 - (byte[@yyyymmdd][1]++ * 367 + 5) / 12
  return yyyymmdd
PUB floor_div(numer, denom)
  if (numer < 0)
    numer -= denom - 1
  return numer / denom
PUB floor_mod(numer, denom)
  result := numer // denom
  if (result < 0)
    result += denom

{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}

