'*********************************************
'* Spin code generated by cspin version 0.82 *
'*********************************************

'******************************************************************************
' Copyright (c) 2014 Dave Hein
' See end of file for terms of use.
'******************************************************************************
' INLINE SPIN
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c : "clibos"


CON
  BUF_SIZE = 10000
  MAX_LINES = 1000

PUB start(argc, argv)
  c.enter
  main(argc, argv)
  c.exit(0)


VAR
  long str1
  long str2
  byte buffer1[1000]
  byte buffer2[1000]

DAT
  global_flag long 0

PUB RemoveCRLF(str) | len
  len := strsize(str)
  repeat while (len--)
    if (byte[str][len] <> 10 and byte[str][len] <> 13)
      quit
    byte[str][len] := 0

PUB Convert(buf1, buf2) | check, len1, len2
  check := 1
  len1 := strsize(str1)
  len2 := strsize(str2)
  repeat while (byte[buf1])
    if (check)
      if (not c.strncmp(buf1, str1, len1))
        c.memcpy(buf2, str2, len2)
        buf2 += len2
        buf1 += len1
        check := global_flag
        next
    byte[buf2++] := byte[buf1++]
  byte[buf2] := 0

PUB FindChar(str, val)
  repeat while (byte[str])
    if (byte[str] == val)
      quit
    str++
  return str

PUB usage
  c.printf0(string("usage: sort -h , or\n"))
  c.printf0(string("usage: sort s/expr/replace/[g] [FILE]...\n"))
  c.exit(0)

PUB main(argc, argv) | i, size, infile, nfiles, delim, cmdptr
  nfiles := 0
  ' Check for help option or no parameters
  if (argc < 2 or not c.strcmp(long[argv][1], string("-h")))
    usage
  ' Check for s command
  if (byte[long[argv][1]][0] <> "s")
    c.printf0(string("Must specify 's' command\n"))
    c.exit(1)
  ' Check the delimiter
  delim := byte[long[argv][1]][1]
  if (not delim)
    c.printf0(string("Must specify a delimiter\n"))
    c.exit(1)
  ' Extract str1 and str2
  str1 := @byte[long[argv][1]][2]
  str2 := FindChar(str1, delim)
  if (byte[str2])
    byte[str2++] := 0
  cmdptr := FindChar(str2, delim)
  if (byte[str2])
    byte[cmdptr++] := 0
  if (byte[cmdptr] == "g")
    global_flag := 1
  elseif (byte[cmdptr])
    c.printf0(string("Invalid command\n"))
    c.exit(1)
  if (argc == 2)
    i := 1
  else
    i := 2

  repeat while (i < argc)
    if (i == 1)
      infile := c.getstdin
    else
      infile := c.fopen(long[argv][i], string("r"))
      if (not infile)
        c.printf1(string("%s: No such file or directory\n"), long[argv][i])
        c.exit(1)
    repeat while (c.fgets(@buffer1, 200, infile))
      RemoveCRLF(@buffer1)
      Convert(@buffer1, @buffer2)
      c.printf1(string("%s\n"), @buffer2)
    if (i > 1)
      c.fclose(infile)
    i++
  'printf("global_flag = %d\n", global_flag);
  return 0

{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}

